<template>
	<div class="FieldsList">
		<div class="text-center py-6" v-if="isLoading">
			<v-progress-circular :size="50" indeterminate color="primary" />
		</div>
		<v-card v-else-if="hasError">
			<v-card-text>There was an error loading resources. Please refresh.</v-card-text>
		</v-card>
		<v-card v-else-if="!hasAccessToFields">
			<v-card-text>
				You do not have access to any fields yet.
				<router-link to="field/new">
					<v-btn class="d-block my-4" rounded color="primary">Add Field</v-btn>
				</router-link>
			</v-card-text>
		</v-card>
		<v-card v-else-if="hasAccessToFields && fieldRows.length === 0">
			<v-card-text>
				No fields match your filters. Try clearing some of your filters to see results, or
				<button @click="clearAllFilters" class="primary--text">clear all filters</button>.
			</v-card-text>
		</v-card>
		<template v-else>
			<field-list-row v-for="fieldRow in fieldsRowsToRender" :key="fieldRow.id" :fieldRow="fieldRow" />
			<v-btn
				block
				v-if="fieldsRowsToRender.length !== fieldRows.length"
				class="FieldsList-viewMore"
				@click="handleViewMore"
			>
				View More
			</v-btn>
		</template>
	</div>
</template>

<script lang="ts">
import { computed, defineComponent, ref, watch, watchEffect } from '@vue/composition-api';
import { FIELDS_LIST_ADDITIONAL_AMOUNT_TO_SHOW_ON_VIEW_MORE, FIELDS_LIST_DEFAULT_NUMBER_TO_RENDER } from '@/constants';
import { useGroups } from '@/store/modules/group';
import { useAllResources } from '@/store/modules/resources';
import { FieldRow } from '@/store/types';
import FieldListRow from './FieldListRow.vue';

export default defineComponent({
	components: {
		FieldListRow,
	},
	setup(_, { root }) {
		const {
			isLoaded: areResourcesLoaded,
			isLoading: areResourcesLoading,
			fields,
			hasError: hasResourcesError,
		} = useAllResources(root.$store);
		const { isLoaded: areGroupsLoaded, isLoading: areGroupsLoading, hasError: hasGroupsError } = useGroups(root.$store);
		const isLoading = computed(() => areGroupsLoading.value || areResourcesLoading.value);
		const isLoaded = computed(() => areGroupsLoaded.value && areResourcesLoaded.value);
		const hasError = computed(() => hasGroupsError.value || hasResourcesError.value);
		const fieldRows = computed<FieldRow[]>(() => root.$store.getters['fieldsView/getFieldRows']);
		const activeFieldRowVisible = computed<boolean>(() => root.$store.getters['fieldsView/getActiveFieldRowVisible']);
		const hasAccessToFields = computed(() => isLoaded.value && fields.value.length > 0);

		const numberToRender = ref(FIELDS_LIST_DEFAULT_NUMBER_TO_RENDER);
		const fieldsRowsToRender = computed(() => fieldRows.value.slice(0, numberToRender.value));
		const handleViewMore = () => {
			numberToRender.value = Math.min(
				fieldRows.value.length,
				numberToRender.value + FIELDS_LIST_ADDITIONAL_AMOUNT_TO_SHOW_ON_VIEW_MORE
			);
		};
		watch(fieldRows, () => {
			numberToRender.value = FIELDS_LIST_DEFAULT_NUMBER_TO_RENDER;
		});

		const clearAllFilters = () => root.$store.dispatch('fieldsView/clearAllFilters');

		watchEffect(() => {
			if (!activeFieldRowVisible.value) {
				root.$store.dispatch('fieldsView/clearActiveFieldId');
			}
		});

		return {
			isLoaded,
			isLoading,
			hasError,
			hasAccessToFields,
			fieldRows,
			clearAllFilters,
			fieldsRowsToRender,
			handleViewMore,
		};
	},
});
</script>

<style lang="scss">
.FieldsList {
	width: 100%;
	height: 100%;
	overflow-y: auto;

	& > .FieldListRow,
	&-viewMore {
		margin-bottom: 8px;
	}

	.v-card:not(.FieldListRow) {
		height: 100%;
	}
}
</style>
